java总结小知识3

xiaoxiao2021-02-28  20

捕获异常

使用 try 和 catch 关键字可以捕获异常。try/catch 代码块放在异常可能发生的地方。

try/catch代码块中的代码称为保护代码,使用 try/catch 的语法如下:

try { // 程序代码 }catch(ExceptionName e1) { //Catch 块 }

Catch 语句包含要捕获异常类型的声明。当保护代码块中发生一个异常时,try 后面的 catch 块就会被检查。

如果发生的异常包含在 catch 块中,异常会被传递到该 catch 块,这和传递一个参数到方法是一样

package lianxi; import java.io.*; import java.text.SimpleDateFormat; import java.util.Calendar; import java.util.Date; public class testClass { public static void main(String args[]) { try { int[] a = new int[2]; /*数组下标越界异常*/ System.out.println("Access element three:" + a[3]); }catch(ArrayIndexOutOfBoundsException e) { System.out.println("Exception thrown :" + e); } } }

多重捕获块

一个 try 代码块后面跟随多个 catch 代码块的情况就叫多重捕获。

多重捕获块的语法如下所示:

try { // 程序代码 } catch ( 异常类型 1 异常的变量名 1 ) { // 程序代码 } catch ( 异常类型 2 异常的变量名 2 ) { // 程序代码 } catch ( 异常类型 2 异常的变量名 2 ) { // 程序代码 }

上面的代码段包含了 3 个 catch块。

可以在 try 语句后面添加任意数量的 catch 块。

如果保护代码中发生异常,异常被抛给第一个 catch 块。

如果抛出异常的数据类型与 ExceptionType1 匹配,它在这里就会被捕获。

如果不匹配,它会被传递给第二个 catch 块。

如此,直到异常被捕获或者通过所有的 catch 块。

throws/throw 关键字:

如果一个方法没有捕获一个检查性异常,那么该方法必须使用 throws 关键字来声明。throws 关键字放在方法签名的尾部。

也可以使用 throw 关键字抛出一个异常,无论它是新实例化的还是刚捕获到的。

import java.io.*; public class className { public void deposit(double amount) throws RemoteException { // Method implementation throw new RemoteException(); } //Remainder of class definition } import java.io.*; public class className { public void withdraw(double amount) throws RemoteException, InsufficientFundsException { // Method implementation } //Remainder of class definition }

finally关键字

finally 关键字用来创建在 try 代码块后面执行的代码块。

无论是否发生异常,finally 代码块中的代码总会被执行。

在 finally 代码块中,可以运行清理类型等收尾善后性质的语句。

finally 代码块出现在 catch 代码块最后,

package lianxi; import java.io.*; import java.rmi.RemoteException; import java.text.SimpleDateFormat; import java.util.Calendar; import java.util.Date; public class testClass { public static void main(String args[]) { int a[] = new int[2]; try { System.out.println("Access element " + a[3]); } catch(ArrayIndexOutOfBoundsException d) { System.out.println("Exception thrown : " + d); } finally { a[0] = 6; System.out.println("First element value: " + a[0]); System.out.println("The finally Statement is executed"); } } }

注意下面事项:

catch 不能独立于 try 存在。 在 try/catch 后面添加 finally 块并非强制性要求的。 try 代码后不能既没 catch 块也没 finally 块。 try, catch, finally 块之间不能添加任何代码。

声明自定义异常

在 Java 中你可以自定义异常。编写自己的异常类时需要记住下面的几点。

所有异常都必须是 Throwable 的子类。 如果希望写一个检查性异常类,则需要继承 Exception 类。 如果你想写一个运行时异常类,那么需要继承 RuntimeException 类。

可以像下面这样定义自己的异常类:

class MyException extends Exception { }

只继承Exception 类来创建的异常类是检查性异常类。

下面的 InsufficientFundsException 类是用户定义的异常类,它继承自 Exception。

一个异常类和其它任何类一样,包含有变量和方法。

理解:所谓捕获异常,就是再定义了一个异常类,然后在出现此异常的时候讲此异常类抛出;

自定义异常类过程:先定义一个异常类,在程序可能出现的异常的地方加一个判断,如果满足异常条件,则抛出一个异常;

在命令行打印异常信息在程序中出错的位置及原因。

以下实例是一个银行账户的模拟,通过银行卡的号码完成识别,可以进行存钱和取钱的操作。

先自定义一个异常类

package lianxi; public class InsufficientException extends Exception{ private double amount; /*此异常是处理取出的钱多余账户的钱,抛出缺乏的钱*/ public InsufficientException (double amount){ this.amount = amount; } public double getAmount() { return amount; } }处理异常的类

package lianxi; public class CheckAmount { private double balance; private int num; public CheckAmount(int num) { this.num = num; } /*存钱*/ public void deposit(double amount) { balance += amount; } /*取钱*/ public void withdraw (double amount) throws InsufficientException{ if(amount <= balance) { balance -=amount; } else { double needs = amount - balance; throw new InsufficientException(needs); } } /*返回余额*/ public double getBalance() { return balance; } /*返回卡号*/ public int getNumber() { return num; } } 示范如何使用

package lianxi; public class BankDemo { public static void main(String[] args) { // TODO Auto-generated method stub CheckAmount c = new CheckAmount(6666); System.out.println("Depositing $500..."); c.deposit(500.00); try { System.out.println("\nWithdrawing $100..."); c.withdraw(100.00); System.out.println("\nWithdrawing $600..."); c.withdraw(600.00); } catch(InsufficientException e) /*定义一个异常类e*/ { System.out.println("Sorry, but you are short $" + e.getAmount());/*抛出异常以及所缺的钱*/ e.printStackTrace();/*在命令行打印异常信息在程序中出错的位置及原因。*/ } } }

通用异常

在Java中定义了两种类型的异常和错误。

JVM(Java虚拟机) 异常:由 JVM 抛出的异常或错误。例如:NullPointerException 类,ArrayIndexOutOfBoundsException 类,ClassCastException 类。 程序级异常:由程序或者API程序抛出的异常。例如 IllegalArgumentException 类,IllegalStateException 类。
转载请注明原文地址: https://www.6miu.com/read-1650280.html

最新回复(0)